
package de.ivu.elect.presentation.staat;

import javax.inject.Inject;
import javax.inject.Named;

import org.apache.deltaspike.core.api.scope.ConversationGroup;

import de.ivu.elect.business.staat.boundary.StaatenGruppeConversationStore;
import de.ivu.elect.business.staat.boundary.StaatenGruppeExtendedDAO;
import de.ivu.elect.business.staat.boundary.StaatenGruppeEdit;
import de.ivu.elect.business.staat.entity.StaatenGruppe;
import de.ivu.elect.business.staat.entity.StaatenGruppeMeta;
import de.ivu.elect.business.security.UseCasePermission;
import de.ivu.elect.business.security.UseCaseSecure;
import de.ivu.elect.presentation.View;
import de.ivu.elect.jee.presentation.redirect.Redirect;

@Named(AbstractStaatenGruppeEditNoScopeView.COMPONENT_NAME)
@View(viewId = AbstractStaatenGruppeEditNoScopeView.VIEW_ID, useCase = UseCasePermission.STAATEN_GRUPPE_EDIT)
public abstract class AbstractStaatenGruppeEditNoScopeView extends de.ivu.elect.presentation.AbstractElectEditView<StaatenGruppe>  {

  private static final long serialVersionUID = 1L;

  public static final String COMPONENT_NAME = "staatenGruppeEditView";

  public static final String VIEW_ID = "/staat/staaten-gruppe-edit.xhtml";

  public static final String PARENT_VIEW_ID = "/staat/staaten-gruppe-search.xhtml";

  @Inject
  protected transient StaatenGruppeExtendedDAO extendedDAO;

  @Inject
  protected transient StaatenGruppeEdit edit;

  @Inject
  @ConversationGroup(StaatenGruppeConversationStore.class)
  protected transient StaatenGruppeConversationStore conversationStore;

  @Inject
  protected transient StaatenGruppeMeta entityMeta;

  @Inject
  // ELECTDD-204 Auf doppelte Bearbeitung von Entitäten Hinweisen
  protected transient StaatenGruppeEditViewScopeStore entityViewStore;

  @de.ivu.elect.jee.faces.PreConditionCheck
  public String checkPreCondition() {
    if (getEntity() == null) {
      return getParentViewId();
    }
    return null;
  }

  @Override
  public StaatenGruppe getEntity() {
    if (conversationStore.getEntityPK() != null) {
      return extendedDAO.findByPrimaryKey(conversationStore.getEntityPK());
    }
    return null;
  }

  public void setEntity(StaatenGruppe entity) {
    resetModel(); // DynaForm-Model zurücksetzen, damit die aktuelle Entität verwendte wird...
    if (entity == null) {
      conversationStore.setEntityPK(null);
    } else {
      conversationStore.setEntityPK(entity.getPk());
    }
  }

  public boolean isEntitySet() {
    return conversationStore.getEntityPK() != null;
  }

  @Redirect
  @UseCaseSecure(UseCasePermission.STAATEN_GRUPPE_DELETE)
  @Override
  public String delete() {
    return delete(getEntity());
  }

  protected String delete(StaatenGruppe entity) {
    edit.delete(entity);

    addMessageDeleteSuccess();

    resetStateAfterAction();
    return getParentViewId(); // definierter Parent, benutze deleteAndGoBack um zum vorherigen View zurückzukehren
  }



  @Redirect
  @UseCaseSecure(UseCasePermission.STAATEN_GRUPPE_DELETE)
  public String deleteAndGoBack() {
    delete();
    return goBack(getParentViewId());
  }

  protected void addMessageDeleteSuccess() {
    addInfoMessage("entity.edit.action.delete.success.message", entityMeta.getEinzahlMessage());
  }

  public boolean isBtnDeleteRendered() {
    return hasPermission(UseCasePermission.STAATEN_GRUPPE_DELETE);
  }

  @Redirect
  @Override
  public String cancel() {
    resetStateAfterAction();

    return goBack(getParentViewId());
  }

  @Override
  public boolean isBtnCancelRendered() {
    return true;
  }

  @Redirect
  @UseCaseSecure(UseCasePermission.STAATEN_GRUPPE_EDIT)
  @Override
  public String save() {
    StaatenGruppe entity = getEntity();

    callSave(entity);

    addMessageSaveSuccess(entity);

    resetStateAfterAction();

    return goBack(getParentViewId());
  }

  protected void callSave(StaatenGruppe entity) {
    edit.save(entity);
  }

  @Redirect
  @Override
  public String reset() {
    super.reset();
    StaatenGruppe entity = getEntity();
    resetStateAfterAction();
    setEntity(entity);
    return getViewId();
  }

  protected void addMessageSaveSuccess(StaatenGruppe entity) {
    addInfoMessage("entity.edit.action.save.success.message", entityMeta.getEinzahlMessage());
  }

  @Override
  protected boolean isSavePermissionVorhanden() {
    return hasPermission(UseCasePermission.STAATEN_GRUPPE_EDIT);
  }
  
  @Redirect
  public String edit(StaatenGruppe entity) {
    conversationStore.setEntityPK(entity.getPk());
    return getViewId();
  }

  protected String getViewId() {
    return VIEW_ID;
  }

  protected String getParentViewId() {
    return PARENT_VIEW_ID;
  }

  protected void resetStateAfterAction() {
    conversationStore.close();
  }

  @de.ivu.elect.jee.faces.PreConditionCheck
  public void checkDoppelteBearbeitung() {
     entityViewStore.setEntity(getEntity());
  }

  @org.apache.deltaspike.core.api.scope.ViewAccessScoped
  public static class StaatenGruppeEditViewScopeStore extends  de.ivu.elect.presentation.edit.AbstractViewScopeStore<StaatenGruppe,   de.ivu.elect.business.staat.entity.StaatenGruppePK  > {

    private static final long serialVersionUID = 1L;
  }
}
